#include <iostream>
#include <string>
#include <bits/stdc++.h>
#include <stdlib.h>
#include <cstdlib>

using namespace std;
int broj(string a,char x)
{
  int s=0;
  for(int i=0;i<a.length();i++)
  {
    if(a[i]==x) s++;
  }
  return s;
}
int main()
{
  int n;
  cin>>n;
  int matrica[n][n];
  string sio[n][n];
  for(int i=0;i<n;i++)
  {
    for(int j=0;j<n;j++)
    {
      matrica[i][j]=300001;
      sio[i][j]="  .  ";
    }
  }
  for(int i=0;i<n;i++)
  {    
    int a,b;
    cin>>a>>b;
    matrica[a][b]=1;
    matrica[b][a]=1;
    cin>>sio[a][b];
    sio[b][a]=sio[a][b];    
  }
  for(int i=0;i<n;i++)
  {
    for(int j=0;j<n;j++)
    {
      for(int k=0;k<n;k++)
      {
        if(matrica[i][j]>matrica[i][k]+matrica[k][j])
        {
          matrica[i][j]=matrica[i][k]+matrica[k][j];
          sio[i][j]=sio[i][k]+sio[k][j];
        }
      } 
    }
  }
  int s=0;
  for(int j=0;j<n;j++)
  {
    for(int k=0;k<n;k++)
    {
      if(broj(sio[j][k],'S')==broj(sio[j][k],'I')==broj(sio[j][k],'O'))
      {
        s++;
      }
    } 
  }
  cout<<s;
}